﻿Imports ThinkGeo.MapSuite.Serialize
Imports ThinkGeo.MapSuite.Shapes
Imports ThinkGeo.MapSuite.WinForms

Public Class frmMain
  Private moWmtsLayer As New CustomWmtsLayer()
  Private sDataPath As String = "..\..\Data\"
  Private moLayer As DataTable
  Private moLayerStyle As DataTable
  Private moTableMatrixLink As DataTable
  Private moWGS84BoundingBox As DataTable
  Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
    Dim oProj4 As New Proj4Projection
    Dim sUri As String = String.Empty

    sUri = "https://basemap.nationalmap.gov/arcgis/rest/services/USGSTopo/MapServer/WMTS/"
    moWmtsLayer.ServerUris.Add(New Uri(sUri))
    moWmtsLayer.DrawingExceptionMode = ThinkGeo.MapSuite.Drawing.DrawingExceptionMode.DrawException
    moWmtsLayer.WmtsSeverEncodingType = ThinkGeo.MapSuite.Layers.WmtsSeverEncodingType.Restful
    moWmtsLayer.Open()


    mAddWmtsLayer()
    WinformsMap1.Refresh()

    Dim sPath As String = "C:\Temp\TestSerializeWmtsLayer"
    Dim sFilename As String = "\TestSerializeWmtsLayer.xml"
    If Not IO.Directory.Exists(sPath) Then
      IO.Directory.CreateDirectory(sPath)
    End If

    Dim oSerializer As New GeoSerializer
    Try
      moWmtsLayer.Close()
      oSerializer.Serialize(moWmtsLayer, sPath + sFilename)
    Catch ex As Exception
      MessageBox.Show(ex.Message, "Yikes!", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
    End Try


  End Sub
  Private Sub mAddWmtsLayer()
    With moWmtsLayer
      .ActiveLayerName = "USGSTopo"
      .ActiveStyleName = "default"
      .TileMatrixSetName = "GoogleMapsCompatible"
    End With

    Dim oOverlay As New LayerOverlay

    WinformsMap1.MapUnit = ThinkGeo.MapSuite.GeographyUnit.Meter
    oOverlay.Layers.Add(moWmtsLayer)

    WinformsMap1.Overlays.Add(oOverlay)
    Dim oRect As New RectangleShape(8466755.57232525, 4918863.47372144, 14332212.7026385, 1699955.39053035)
    WinformsMap1.CurrentExtent = oRect

  End Sub
End Class
